unit Unit1;

interface

uses
  Windows,
  Messages,
  SysUtils,
  //Variants,
  Graphics,
  Forms,
  Dialogs,
  inifiles,
  //StdCtrls,
  Classes,
   ExtCtrls,
    Controls,
     ComCtrls,
      StdCtrls,
       Grlink;

type
  TForm1 = class(TForm)
    Timer1: TTimer;
    Image1: TImage;
    TrackBar1: TTrackBar;
    Label1: TLabel;
    Grlink1: TGrlink;
    Label2: TLabel;
    CheckBox1: TCheckBox;
    TrackBar2: TTrackBar;
    Label3: TLabel;
    procedure FormCreate(Sender: TObject);
    {     My function}
    function KorRect(i: integer): TRect;
    function RunColor: TColor;
    procedure Kor(i: integer);
    procedure ChengeRect(i,i1: integer);
    procedure RunSettings;
    procedure RunOptions;
    {! END    My function}
    procedure Timer1Timer(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
    procedure Image1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  num, dl, vs: integer;
  Point: TPoint;
  //time: integer; //  

implementation

{$R *.dfm}
//{$R logo.res}

function TForm1.RunColor: TColor;
var i: integer;
color: array[0..14] of TColor;
begin
{  }
color[0]:=clBlue;   color[5]:=clWhite;   color[10]:=clAqua;
color[1]:=clYellow; color[6]:=clGreen;   color[11]:=clMaroon;
color[2]:=clNavy;   color[7]:=clPurple;  color[12]:=clGray;
color[3]:=clLime;   color[8]:=clFuchsia; color[13]:=clBlack;
color[4]:=clOlive;  color[9]:=clSilver;  color[14]:=clTeal;

Randomize;
i:= Random(Length(color));
result:=color[i];
end;

function TForm1.KorRect(i: integer): TRect;
var x, y, z, e, e1, r: integer;
    m, m1: integer;
begin
x := Screen.Width;
y := Screen.Height;
m:=(x)div(dl);
m1:=(y)div(vs);
{     }
e:=0; e1:=1;
r:=0;
for z:=1 to vs*dl do
    begin
    if e = dl then
       begin
       e1:=e1+1;
       e:=0;
       end;
    if r = vs+1 then
       begin
       r:=0;
       end;
    if i = z then Break;
    e:=e+1;
    r:=r+1;
    end;
e1:=e1-1;
result:=Bounds(r*m, e1*m1, (r*m)+m, (e1*m1)+m1);
end;

procedure TForm1.ChengeRect(i,i1: integer);
var BufMap, BitMap: TBitMap;
    BufRect, Rect: TRect;
    x,y: integer;
Begin
x := Screen.Width;
y := Screen.Height;
//  BitMap
BufMap:= TBitMap.Create;
BitMap:= TBitMap.Create;
{ -  i}
BufRect:=KorRect(i1);
Rect:=KorRect(i);
BufRect:=Bounds(0,0,Rect.Right - Rect.Left,Rect.Bottom - Rect.Top);
BufMap.Height:=(y)div(vs);   BitMap.Height:=(y)div(vs);
BufMap.Width := (x)div(dl);  BitMap.Width := (x)div(dl);

BufMap.Canvas.CopyRect(BufRect, Image1.Canvas, Rect);
BufRect:=KorRect(i1);
Rect:=Bounds(0,0,BufRect.Right - BufRect.Left,BufRect.Bottom - BufRect.Top);
BitMap.Canvas.CopyRect(Rect, Image1.Canvas, BufRect);

Rect:=KorRect(i);
Image1.Canvas.Draw(BufRect.left, BufRect.top, BufMap);
Image1.Canvas.Draw(Rect.left, Rect.top, BitMap);
{ BitMap FREE .. > }
BufMap.Free;
BitMap.Free;
end;

procedure TForm1.Kor(i: integer);
var x, y, z, e, e1, r: integer;
    m, m1: integer;
begin
{     }
x := Screen.Width;
y := Screen.Height;
{  . /  .  }
m:=(x)div(dl);  // 
m1:=(y)div(vs); // 
{     }
e:=0; e1:=1;
r:=0;
for z:=1 to vs*dl do
    begin
    if e = dl then
       begin
       e1:=e1+1;
       e:=0;
       end;
    if r = vs+1 then
       begin
       r:=0;
       end;
    if i = z then Break;
    e:=e+1;
    r:=r+1;
    end;
e1:=e1-1;

Image1.Canvas.Brush.Color:= RunColor;
Image1.Canvas.Pen.Color:= Image1.Canvas.Brush.Color;
Image1.Canvas.Rectangle(r*m,      e1*m1,
                       (r*m)+m,  (e1*m1)+m1);
end;

procedure TForm1.FormCreate(Sender: TObject);
var S : String;
   CDini: TIniFile;
Begin
//   ini 
CDini:=TIniFile.Create(Application.ExeName+'.ini');
TrackBar1.Position:=CDini.ReadInteger('Position','TrackBar1',TrackBar1.Position);
TrackBar2.Position:=CDini.ReadInteger('Position','TrackBar2',TrackBar2.Position);
CheckBox1.Checked:=CDini.ReadBool('Checked','CheckBox1',CheckBox1.Checked);
CDini.Free;
//  
S := ParamStr(1);
  If (Length(S) > 1) Then
  Begin
  Delete(S,1,1);
  S[1] := UpCase(S[1]);
  End;
If (S = 'S') Then RunSettings
  Else {If (S = 'C') Then} RunOptions;

//ShowMessage(s);
//RunOptions;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
var i, i1: integer;
p: TPoint;
begin
GetCursorPos(P);
if Point.y <> p.y then Close;
if Point.x <> p.x then Close;
if not(CheckBox1.Checked) then
   Begin
   Randomize;
   i1:=Random(dl*vs+1);
   i:=Random(dl*vs+1);
   if i = 0 then i :=1;
   if i1 = 0 then i1 :=2;
   ChengeRect(i, i1);
   end
 else 
   begin
   i:=Random(dl*vs+1);
   if i = 0 then i :=1;
   Kor(i);
   end;
end;

procedure TForm1.RunSettings;
var ScreenDC:HDC;
    Canvas: TCanvas;
begin
Form1.BorderStyle:= bsNone;
Image1.Align:=alClient;
Image1.Stretch:=true;
{ }
GetCursorPos(Point);
{Run ScreenSave}
ShowCursor(False);
Form1.Top:=0; Form1.Left:=0;
Form1.Width:= Screen.Width;
Form1.Height:= Screen.Height;
Image1.Width:= Screen.Width;
Image1.Height:= Screen.Height;
ScreenDC:=GetDC(0);
Canvas:= TCanvas.Create;
Canvas.Handle:= ScreenDC;

Image1.Canvas.CopyRect(Rect(0,0,Screen.Width,Screen.Height),Canvas,
Rect(0,0,Screen.Width,Screen.Height));
//ChengeRect(1, 30);
//dl, vs
case TrackBar1.Position of
 0: vs:=2;
 1: vs:=3;
 2: vs:=6;
 3: vs:=10;
 4: vs:=15;
 5: vs:=20;
 6: vs:=25;
 7: vs:=30;
 8: vs:=35;
 9: vs:=40;
10: vs:=50;
end;
dl:=vs+1;
case TrackBar2.Position of
 0: Timer1.Interval:=3000;
 1: Timer1.Interval:=2000;
 2: Timer1.Interval:=1000;
 3: Timer1.Interval:=900;
 4: Timer1.Interval:=800;
 5: Timer1.Interval:=500;
 6: Timer1.Interval:=400;
 7: Timer1.Interval:=300;
 8: Timer1.Interval:=100;
 9: Timer1.Interval:=80;
10: Timer1.Interval:=50;
end;
Timer1.Enabled:=true;
end;

procedure TForm1.RunOptions;
var logo: TbitMap;
begin
//Image1.Free;
logo:= TBitMap.Create;
logo.LoadFromResourceName(HInstance,'LOGO');
Form1.Image1.Canvas.Draw(0,0,logo);
logo.Free;
TrackBar1.Visible:=true;
Label1.Visible:=true;
Label2.Visible:=true;
Grlink1.Visible:=true;
CheckBox1.Visible:=true;
Label3.Visible:=true;
TrackBar2.Visible:=true;
end;

procedure TForm1.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
var CDini: TIniFile;
begin
//   ini 
CDini:=TIniFile.Create(Application.ExeName+'.ini');
CDini.WriteInteger('Position','TrackBar1',TrackBar1.Position);
CDini.WriteInteger('Position','TrackBar2',TrackBar2.Position);
CDini.WriteBool('Checked','CheckBox1',CheckBox1.Checked);
CDini.Free;
//  
ShowCursor(True);
end;

procedure TForm1.FormKeyPress(Sender: TObject; var Key: Char);
begin
Close;
end;

procedure TForm1.Image1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
Close;
end;

end.
